/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.53 Revision 1.112
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.53 2009/11/25 19:51:11 tampakrap Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.112 2012/01/17 11:20:03 johu Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.X ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 based ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: KDE 4 ebuilds by default define EAPI="2", this can be redefined but 13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed
14# eclass will fail with version older than 2. 14# over time as new EAPI versions are approved.
15
16# @ECLASS-VARIABLE: KDE_SELINUX_MODULE
17# @DESCRIPTION:
18# If set to "none", do nothing.
19# For any other value, add selinux to IUSE, and depending on that useflag
20# add a dependency on sec-policy/selinux-${KDE_SELINUX_MODULE} to (R)DEPEND
21: ${KDE_SELINUX_MODULE:=none}
22
23# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
24# @DESCRIPTION:
25# For proper description see virtualx.eclass manpage.
26# Here we redefine default value to be manual, if your package needs virtualx
27# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
28: ${VIRTUALX_REQUIRED:=manual}
29
30inherit kde4-functions toolchain-funcs fdo-mime gnome2-utils base virtualx versionator eutils
31
32if [[ ${BUILD_TYPE} = live ]]; then
33 case ${KDE_SCM} in
34 svn) inherit subversion ;;
35 git) inherit git-2 ;;
36 esac
37fi
15 38
16# @ECLASS-VARIABLE: CMAKE_REQUIRED 39# @ECLASS-VARIABLE: CMAKE_REQUIRED
17# @DESCRIPTION: 40# @DESCRIPTION:
18# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'. 41# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
19# Please note that if it's set to 'never' you need to explicitly override following phases: 42# Please note that if it's set to 'never' you need to explicitly override following phases:
20# src_configure, src_compile, src_test and src_install. 43# src_configure, src_compile, src_test and src_install.
21# Defaults to 'always'. 44# Defaults to 'always'.
22CMAKE_REQUIRED="${CMAKE_REQUIRED:-${CMAKE_REQUIRED:-always}}" 45: ${CMAKE_REQUIRED:=always}
23if [[ ${CMAKE_REQUIRED} = false || ${CMAKE_REQUIRED} = never ]]; then 46if [[ ${CMAKE_REQUIRED} = always ]]; then
24 buildsystem_eclass=""
25 export_fns=""
26else
27 buildsystem_eclass="cmake-utils" 47 buildsystem_eclass="cmake-utils"
28 export_fns="src_configure src_compile src_test src_install" 48 export_fns="src_configure src_compile src_test src_install"
29fi 49fi
30 50
31inherit kde4-functions 51# @ECLASS-VARIABLE: KDE_MINIMAL
52# @DESCRIPTION:
53# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
54# version for apps to work. Currently defaults to 4.4
55# One may override this variable to raise version requirements.
56# Note that it is fixed to ${PV} for kde-base packages.
57KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
32 58
33get_build_type 59# Set slot for KDEBASE known packages
60case ${KDEBASE} in
61 kde-base)
62 SLOT=4
63 KDE_MINIMAL="${PV}"
64 ;;
65 koffice)
66 SLOT="2"
67 ;;
68 kdevelop)
34if [[ ${BUILD_TYPE} = live ]]; then 69 if [[ ${BUILD_TYPE} = live ]]; then
35 subversion_eclass="subversion" 70 # @ECLASS-VARIABLE: KDEVELOP_VERSION
36fi 71 # @DESCRIPTION:
72 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
73 # Applies to KDEBASE=kdevelop only.
74 KDEVELOP_VERSION="${KDEVELOP_VERSION:-9999}"
75 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
76 # @DESCRIPTION:
77 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
78 # Applies to KDEBASE=kdevelop only.
79 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-9999}"
80 else
81 case ${PN} in
82 kdevelop|quanta)
83 KDEVELOP_VERSION=${PV}
84 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
85 ;;
86 kdevplatform)
87 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
88 KDEVPLATFORM_VERSION=${PV}
89 ;;
90 *)
91 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
92 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-1.0.0}"
93 esac
94 fi
95 SLOT="4"
96 ;;
97esac
37 98
38inherit base ${buildsystem_eclass} eutils ${subversion_eclass} 99inherit ${buildsystem_eclass}
39 100
40EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_postinst pkg_postrm 101EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_preinst pkg_postinst pkg_postrm
41 102
42unset buildsystem_eclass 103unset buildsystem_eclass
43unset export_fns 104unset export_fns
44unset subversion_eclass
45 105
106# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
107# @DESCRIPTION:
108# Is qt-declarative required? Possible values are 'always', 'optional' and 'never'.
109# This variable must be set before inheriting any eclasses. Defaults to 'never'.
110DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
111
112# @ECLASS-VARIABLE: QTHELP_REQUIRED
113# @DESCRIPTION:
114# Is qt-assistant required? Possible values are 'always', 'optional' and 'never'.
115# This variable must be set before inheriting any eclasses. Defaults to 'never'.
116QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
117
118# @ECLASS-VARIABLE: OPENGL_REQUIRED
119# @DESCRIPTION:
120# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'.
121# This variable must be set before inheriting any eclasses. Defaults to 'never'.
122OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
123
124# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
125# @DESCRIPTION:
126# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'.
127# This variable must be set before inheriting any eclasses. Defaults to 'never'.
128MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
129
130# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
131# @DESCRIPTION:
132# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
133# This variable must be set before inheriting any eclasses. Defaults to 'never'.
134CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
135
136# @ECLASS-VARIABLE: KDE_REQUIRED
137# @DESCRIPTION:
138# Is kde required? Possible values are 'always', 'optional' and 'never'.
139# This variable must be set before inheriting any eclasses. Defaults to 'always'
140# If set to 'always' or 'optional', KDE_MINIMAL may be overriden as well.
141# Note that for kde-base packages this variable is fixed to 'always'.
142KDE_REQUIRED="${KDE_REQUIRED:-always}"
143
144# @ECLASS-VARIABLE: KDE_HANDBOOK
145# @DESCRIPTION:
146# Set to enable handbook in application. Possible values are 'always', 'optional'
147# (handbook USE flag) and 'never'.
148# This variable must be set before inheriting any eclasses. Defaults to 'never'.
149# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
150# ensures buildtime and runtime dependencies.
151KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
152
153# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
154# @DESCRIPTION:
155# Set this varible if you want your live package to manage its
156# translations. (Mostly all kde ebuilds does not ship documentation
157# and translations in live ebuilds)
158if [[ ${BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
159 # Kdebase actualy provides the handbooks even for live stuff
160 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
161 KDE_LINGUAS=""
162fi
163
164# Setup packages inheriting this eclass
46case ${KDEBASE} in 165case ${KDEBASE} in
47 kde-base) 166 kde-base)
48 HOMEPAGE="http://www.kde.org/" 167 HOMEPAGE="http://www.kde.org/"
49 LICENSE="GPL-2" 168 LICENSE="GPL-2"
50 ;;
51 koffice)
52 HOMEPAGE="http://www.koffice.org/"
53 LICENSE="GPL-2"
54 ;;
55esac
56
57# @ECLASS-VARIABLE: OPENGL_REQUIRED
58# @DESCRIPTION:
59# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'.
60# This variable must be set before inheriting any eclasses. Defaults to 'never'.
61OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
62
63# @ECLASS-VARIABLE: WEBKIT_REQUIRED
64# @DESCRIPTION:
65# Is qt-webkit requred? Possible values are 'always', 'optional' and 'never'.
66# This variable must be set before inheriting any eclasses. Defaults to 'never'.
67WEBKIT_REQUIRED="${WEBKIT_REQUIRED:-never}"
68
69# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
70# @DESCRIPTION:
71# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
72# This variable must be set before inheriting any eclasses. Defaults to 'never'.
73CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
74
75# @ECLASS-VARIABLE: KDE_REQUIRED
76# @DESCRIPTION:
77# Is kde required? Possible values are 'always', 'optional' and 'never'.
78# This variable must be set before inheriting any eclasses. Defaults to 'always'
79# If set to always or optional, KDE_MINIMAL may be overriden as well.
80# Note that for kde-base packages this variable is fixed to 'always'.
81KDE_REQUIRED="${KDE_REQUIRED:-always}"
82
83# Verify KDE_MINIMAL (display QA notice in pkg_setup, still we need to fix it here)
84if [[ -n ${KDE_MINIMAL} ]]; then
85 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
86 [[ ${KDE_MINIMAL} = ${slot} ]] && KDE_MINIMAL_VALID=1 && break
87 done
88 unset slot
89 [[ -z ${KDE_MINIMAL_VALID} ]] && unset KDE_MINIMAL
90else
91 KDE_MINIMAL_VALID=1
92fi
93
94# @ECLASS-VARIABLE: KDE_MINIMAL
95# @DESCRIPTION:
96# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
97# version for apps to work. Currently defaults to 4.3
98# One may override this variable to raise version requirements.
99# For possible values look at KDE_SLOTS and KDE_LIVE_SLOTS variables.
100# Note that it is fixed to ${SLOT} for kde-base packages.
101KDE_MINIMAL="${KDE_MINIMAL:-4.3}"
102
103# Setup packages inheriting this eclass
104case ${KDEBASE} in
105 kde-base)
106 if [[ $BUILD_TYPE = live ]]; then 169 if [[ $BUILD_TYPE = live ]]; then
107 # Disable tests for live ebuilds 170 # Disable tests for live ebuilds
108 RESTRICT+=" test" 171 RESTRICT+=" test"
109 # Live ebuilds in kde-base default to kdeprefix by default 172 fi
110 IUSE+=" +kdeprefix" 173
111 else 174 # Only add the kdeprefix USE flag for older versions, to help
112 # All other ebuild types default to -kdeprefix as before 175 # non-portage package managers handle the upgrade
176 if [[ ${PV} < 4.6.4 && ( ( ${KMNAME} != kdepim && ${PN} != kdepim-runtime ) || ${PV} < 4.6 ) ]]; then
113 IUSE+=" kdeprefix" 177 IUSE+=" kdeprefix"
114 fi 178 fi
115 # Determine SLOT from PVs 179
116 case ${PV} in
117 *.9999*) SLOT="${PV/.9999*/}" ;; # stable live
118 4.4* | 4.3.[6-9]*) SLOT="4.4" ;;
119 4.3*) SLOT="4.3" ;;
120 4.2*) SLOT="4.2" ;;
121 9999*) SLOT="live" ;; # regular live
122 *) die "Unsupported ${PV}" ;;
123 esac
124 # This code is to prevent portage from searching GENTOO_MIRRORS for 180 # This code is to prevent portage from searching GENTOO_MIRRORS for
125 # packages that will never be mirrored. (As they only will ever be in 181 # packages that will never be mirrored. (As they only will ever be in
126 # the overlay). 182 # the overlay).
127 case ${PV} in 183 case ${PV} in
128 *9999* | 4.?.[6-9]?) 184 *9999* | 4.?.[6-9]?)
129 RESTRICT+=" mirror" 185 RESTRICT+=" mirror"
130 ;; 186 ;;
131 esac 187 esac
132 KDE_MINIMAL="${SLOT}"
133 _kdedir="${SLOT}"
134
135 # Block installation of other SLOTS unless kdeprefix
136 RDEPEND+=" $(block_other_slots)"
137 ;; 188 ;;
138 koffice) 189 koffice)
139 SLOT="2" 190 HOMEPAGE="http://www.koffice.org/"
191 LICENSE="GPL-2"
192 ;;
193 kdevelop)
194 HOMEPAGE="http://www.kdevelop.org/"
195 LICENSE="GPL-2"
140 ;; 196 ;;
141esac 197esac
142 198
143# @ECLASS-VARIABLE: QT_MINIMAL 199# @ECLASS-VARIABLE: QT_MINIMAL
144# @DESCRIPTION: 200# @DESCRIPTION:
145# Determine version of qt we enforce as minimal for the package. 4.4.0 4.5.1.. 201# Determine version of qt we enforce as minimal for the package.
146# Currently defaults to 4.5.1 for KDE 4.3 and earlier
147# or 4.6.0_beta for KDE 4.4 and later
148if slot_is_at_least 4.4 "${KDE_MINIMAL}"; then 202if version_is_at_least 4.7.80 "${KDE_MINIMAL}"; then
203 QT_MINIMAL="${QT_MINIMAL:-4.7.4}"
204else
149 QT_MINIMAL="${QT_MINIMAL:-4.6.0_beta}" 205 QT_MINIMAL="${QT_MINIMAL:-4.7.0}"
150fi 206fi
151 207
152QT_MINIMAL="${QT_MINIMAL:-4.5.1}" 208# Declarative dependencies
209qtdeclarativedepend="
210 >=x11-libs/qt-declarative-${QT_MINIMAL}:4
211"
212case ${DECLARATIVE_REQUIRED} in
213 always)
214 COMMONDEPEND+=" ${qtdeclarativedepend}"
215 ;;
216 optional)
217 IUSE+=" declarative"
218 COMMONDEPEND+=" declarative? ( ${qtdeclarativedepend} )"
219 ;;
220 *) ;;
221esac
222unset qtdeclarativedepend
223
224# QtHelp dependencies
225qthelpdepend="
226 >=x11-libs/qt-assistant-${QT_MINIMAL}:4
227"
228case ${QTHELP_REQUIRED} in
229 always)
230 COMMONDEPEND+=" ${qthelpdepend}"
231 ;;
232 optional)
233 IUSE+=" qthelp"
234 COMMONDEPEND+=" qthelp? ( ${qthelpdepend} )"
235 ;;
236esac
237unset qthelpdepend
153 238
154# OpenGL dependencies 239# OpenGL dependencies
155qtopengldepend=" 240qtopengldepend="
156 >=x11-libs/qt-opengl-${QT_MINIMAL}:4 241 >=x11-libs/qt-opengl-${QT_MINIMAL}:4
157" 242"
165 ;; 250 ;;
166 *) ;; 251 *) ;;
167esac 252esac
168unset qtopengldepend 253unset qtopengldepend
169 254
170# WebKit dependencies 255# MultiMedia dependencies
256qtmultimediadepend="
257 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4
258"
171case ${KDE_REQUIRED} in 259case ${MULTIMEDIA_REQUIRED} in
172 always) 260 always)
173 qtwebkitusedeps="[kde]" 261 COMMONDEPEND+=" ${qtmultimediadepend}"
174 ;; 262 ;;
175 optional) 263 optional)
176 qtwebkitusedeps="[kde?]" 264 IUSE+=" multimedia"
265 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
177 ;; 266 ;;
178 *) ;; 267 *) ;;
179esac 268esac
180qtwebkitdepend=" 269unset qtmultimediadepend
181 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
182"
183unset qtwebkitusedeps
184case ${WEBKIT_REQUIRED} in
185 always)
186 COMMONDEPEND+=" ${qtwebkitdepend}"
187 ;;
188 optional)
189 IUSE+=" webkit"
190 COMMONDEPEND+=" webkit? ( ${qtwebkitdepend} )"
191 ;;
192 *) ;;
193esac
194unset qtwebkitdepend
195 270
196# CppUnit dependencies 271# CppUnit dependencies
197cppuintdepend=" 272cppuintdepend="
198 dev-util/cppunit 273 dev-util/cppunit
199" 274"
207 ;; 282 ;;
208 *) ;; 283 *) ;;
209esac 284esac
210unset cppuintdepend 285unset cppuintdepend
211 286
287
288# WebKit use dependencies
289case ${KDE_REQUIRED} in
290 always)
291 qtwebkitusedeps="[kde]"
292 ;;
293 optional)
294 qtwebkitusedeps="[kde?]"
295 ;;
296 *) ;;
297esac
212# KDE dependencies 298# KDE dependencies
299# Qt accessibility classes are needed in various places, bug 325461
213kdecommondepend=" 300kdecommondepend="
214 dev-lang/perl 301 dev-lang/perl
215 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl] 302 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl]
216 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus] 303 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus]
217 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde] 304 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde]
218 >=x11-libs/qt-script-${QT_MINIMAL}:4 305 >=x11-libs/qt-script-${QT_MINIMAL}:4
219 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support] 306 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support]
220 >=x11-libs/qt-svg-${QT_MINIMAL}:4 307 >=x11-libs/qt-svg-${QT_MINIMAL}:4
221 >=x11-libs/qt-test-${QT_MINIMAL}:4 308 >=x11-libs/qt-test-${QT_MINIMAL}:4
309 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
222 !aqua? ( 310 !aqua? (
223 x11-libs/libXext 311 x11-libs/libXext
224 x11-libs/libXt 312 x11-libs/libXt
225 x11-libs/libXxf86vm 313 x11-libs/libXxf86vm
314 x11-libs/libXcomposite
315 x11-libs/libxkbfile
226 ) 316 )
227" 317"
318
228if [[ ${PN} != kdelibs ]]; then 319if [[ ${PN} != kdelibs ]]; then
229 if [[ ${KDEBASE} = kde-base ]]; then
230 kdecommondepend+=" $(add_kdebase_dep kdelibs)" 320 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
231 # libknotificationitem only when SLOT is 4.3 321 if [[ ${KDEBASE} = kdevelop ]]; then
232 [[ ${PN} != libknotificationitem ]] && [[ ${SLOT} = 4.3 ]] && \ 322 if [[ ${PN} != kdevplatform ]]; then
233 kdecommondepend+=" $(add_kdebase_dep libknotificationitem)" 323 # @ECLASS-VARIABLE: KDEVPLATFORM_REQUIRED
234 else 324 # @DESCRIPTION:
325 # Specifies whether kdevplatform is required. Possible values are 'always' (default) and 'never'.
326 # Applies to KDEBASE=kdevelop only.
327 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
328 case ${KDEVPLATFORM_REQUIRED} in
329 always)
235 kdecommondepend+=" 330 kdecommondepend+="
236 >=kde-base/kdelibs-${KDE_MINIMAL} 331 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}
332 "
333 ;;
334 *) ;;
335 esac
336 fi
337 fi
338fi
339
340kdedepend="
341 dev-util/automoc
342 dev-util/pkgconfig
343 !aqua? (
344 >=x11-libs/libXtst-1.1.0
345 x11-proto/xf86vidmodeproto
346 )
347"
348
349kderdepend=""
350
351# all packages needs oxygen icons for basic iconset
352if [[ ${PN} != oxygen-icons ]]; then
353 kderdepend+=" $(add_kdebase_dep oxygen-icons)"
354fi
355
356# add a dependency over kde-l10n if EAPI4 or better is around
357if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} && ${EAPI:-0} != 3 ]]; then
358 for _lingua in ${KDE_LINGUAS}; do
359 # if our package has lignuas, pull in kde-l10n with selected lingua enabled,
360 # but only for selected ones.
361 # this can't be done on one line because if user doesn't use any localisation
362 # then he is probably not interested in kde-l10n at all.
363 kderdepend+="
364 linguas_${_lingua}? ( $(add_kdebase_dep kde-l10n "linguas_${_lingua}(+)") )
237 " 365 "
238 fi 366 done
367 unset _lingua
239fi 368fi
240kdedepend=" 369
241 dev-util/pkgconfig 370kdehandbookdepend="
371 app-text/docbook-xml-dtd:4.2
372 app-text/docbook-xsl-stylesheets
242" 373"
374kdehandbookrdepend="
375 $(add_kdebase_dep kdelibs 'handbook')
376"
377case ${KDE_HANDBOOK} in
378 always)
379 kdedepend+=" ${kdehandbookdepend}"
380 [[ ${PN} != kdelibs ]] && kderdepend+=" ${kdehandbookrdepend}"
381 ;;
382 optional)
383 IUSE+=" +handbook"
384 kdedepend+=" handbook? ( ${kdehandbookdepend} )"
385 [[ ${PN} != kdelibs ]] && kderdepend+=" handbook? ( ${kdehandbookrdepend} )"
386 ;;
387 *) ;;
388esac
389unset kdehandbookdepend kdehandbookrdepend
390
391case ${KDE_SELINUX_MODULE} in
392 none) ;;
393 *)
394 IUSE+=" selinux"
395 kdecommondepend+=" selinux? ( sec-policy/selinux-${KDE_SELINUX_MODULE} )"
396 ;;
397esac
398
243case ${KDE_REQUIRED} in 399case ${KDE_REQUIRED} in
244 always) 400 always)
245 IUSE+=" aqua" 401 IUSE+=" aqua"
246 COMMONDEPEND+=" ${kdecommondepend}" 402 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
247 DEPEND+=" ${kdedepend}" 403 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
404 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
248 ;; 405 ;;
249 optional) 406 optional)
250 IUSE+=" aqua kde" 407 IUSE+=" aqua kde"
251 COMMONDEPEND+=" kde? ( ${kdecommondepend} )" 408 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
252 DEPEND+=" kde? ( ${kdedepend} )" 409 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
410 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
253 ;; 411 ;;
254 *) ;; 412 *) ;;
255esac 413esac
414
256unset kdecommondepend kdedepend 415unset kdecommondepend kdedepend kderdepend
257 416
258debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}" 417debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}"
259debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}" 418debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}"
260debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}" 419debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}"
261 420
264RDEPEND+=" ${COMMONDEPEND}" 423RDEPEND+=" ${COMMONDEPEND}"
265unset COMMONDEPEND 424unset COMMONDEPEND
266 425
267# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 426# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
268# koffice ebuild, the URI should be set in the ebuild itself 427# koffice ebuild, the URI should be set in the ebuild itself
269case ${BUILD_TYPE} in 428_calculate_src_uri() {
270 live) 429 debug-print-function ${FUNCNAME} "$@"
271 # Determine branch URL based on live type 430
272 local branch_prefix 431 local _kmname _kmname_pv
432
433 # we calculate URI only for known KDEBASE modules
434 [[ -n ${KDEBASE} ]] || return
435
436 # calculate tarball module name
437 if [[ -n ${KMNAME} ]]; then
438 # fixup kdebase-apps name
273 case ${PV} in 439 case ${KMNAME} in
274 9999*) 440 kdebase-apps)
275 # trunk 441 _kmname="kdebase" ;;
276 branch_prefix="trunk/KDE"
277 ;;
278 *) 442 *)
279 # branch 443 _kmname="${KMNAME}" ;;
280 branch_prefix="branches/KDE/${SLOT}"
281 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
282 # @DESCRIPTION
283 # Suffix appended to ESVN_PROJECT depending on fetched branch.
284 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
285 ESVN_PROJECT_SUFFIX="-${PV}"
286 ;;
287 esac 444 esac
288 SRC_URI="" 445 else
289 # @ECLASS-VARIABLE: ESVN_MIRROR 446 _kmname=${PN}
290 # @DESCRIPTION: 447 fi
291 # This variable allows easy overriding of default kde mirror service 448 _kmname_pv="${_kmname}-${PV}"
292 # (anonsvn) with anything else you might want to use. 449 case ${KDEBASE} in
293 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde} 450 kde-base)
294 # Split ebuild, or extragear stuff 451 case ${PV} in
295 if [[ -n ${KMNAME} ]]; then 452 4.[456789].8[05] | 4.[456789].9[0235678])
296 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}" 453 # Unstable KDE SC releases
297 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then 454 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2"
298 KMMODULE="${PN}" 455 if ! version_is_at_least 4.6.80 ${PV}
456 then
457 # KDEPIM IS SPECIAL
458 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/unstable/kdepim/${PV}/${_kmname_pv}.tar.bz2"
299 fi 459 fi
300 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
301 case ${KMNAME} in
302 kdebase-*)
303 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}"
304 ;;
305 kdelibs-*)
306 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
307 ;;
308 kdereview)
309 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
310 ;;
311 kdesupport)
312 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
313 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
314 ;;
315 kde*)
316 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
317 ;;
318 extragear*|playground*)
319 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
320 # build packages from same svn location.
321 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
322 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
323 ;;
324 koffice)
325 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
326 ;; 460 ;;
327 *) 461 *)
328 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}" 462 # Stable KDE SC releases
463 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2"
464 if ! version_is_at_least 4.6.80 ${PV}
465 then
466 # KDEPIM IS SPECIAL
467 # TODO: It might not be with KDE 4.7 (see above)
468 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2"
469 fi
470 ;;
471 esac
472 ;;
473 koffice)
474 case ${PV} in
475 2.[1234].[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
476 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
477 esac
478 ;;
479 kdevelop)
480 SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2"
481 ;;
482 esac
483}
484
485_calculate_live_repo() {
486 debug-print-function ${FUNCNAME} "$@"
487
488 SRC_URI=""
489 case ${KDE_SCM} in
490 svn)
491 # Determine branch URL based on live type
492 local branch_prefix
493 case ${PV} in
494 9999*)
495 # trunk
496 branch_prefix="trunk/KDE"
497 ;;
498 *)
499 # branch
500 branch_prefix="branches/KDE/$(get_kde_version)"
501 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
502 # @DESCRIPTION
503 # Suffix appended to ESVN_PROJECT depending on fetched branch.
504 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
505 ESVN_PROJECT_SUFFIX="-${PV}"
329 ;; 506 ;;
330 esac 507 esac
331 else
332 # kdelibs, kdepimlibs
333 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
334 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
335 fi
336 # @ECLASS-VARIABLE: ESVN_UP_FREQ 508 # @ECLASS-VARIABLE: ESVN_MIRROR
337 # @DESCRIPTION: 509 # @DESCRIPTION:
338 # This variable is used for specifying the timeout between svn synces 510 # This variable allows easy overriding of default kde mirror service
339 # for kde-base and koffice modules. Does not affect misc apps. 511 # (anonsvn) with anything else you might want to use.
340 # Default value is 1 hour. 512 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
341 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1} 513 # Split ebuild, or extragear stuff
342 ;;
343 *)
344 if [[ -n ${KDEBASE} ]]; then
345 if [[ -n ${KMNAME} ]]; then 514 if [[ -n ${KMNAME} ]]; then
515 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
516 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
517 KMMODULE="${PN}"
518 fi
519 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
346 case ${KMNAME} in 520 case ${KMNAME} in
347 kdebase-apps) 521 kdebase-*)
348 _kmname="kdebase" ;; 522 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}"
523 ;;
524 kdelibs-*)
525 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
526 ;;
527 kdereview*)
528 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
529 ;;
530 kdesupport)
531 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
532 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
533 ;;
534 kde*)
535 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
536 ;;
537 extragear*|playground*)
538 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
539 # build packages from same svn location.
540 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
541 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
542 ;;
543 koffice)
544 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
545 ;;
349 *) 546 *)
350 _kmname="${KMNAME}" ;; 547 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
548 ;;
351 esac 549 esac
550 else
551 # kdelibs, kdepimlibs
552 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
553 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
554 fi
555 # @ECLASS-VARIABLE: ESVN_UP_FREQ
556 # @DESCRIPTION:
557 # This variable is used for specifying the timeout between svn synces
558 # for kde-base and koffice modules. Does not affect misc apps.
559 # Default value is 1 hour.
560 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
561 ;;
562 git)
563 local _kmname
564 # @ECLASS-VARIABLE: EGIT_MIRROR
565 # @DESCRIPTION:
566 # This variable allows easy overriding of default kde mirror service
567 # (anongit) with anything else you might want to use.
568 EGIT_MIRROR=${EGIT_MIRROR:=git://anongit.kde.org}
569
570 # @ECLASS-VARIABLE: EGIT_REPONAME
571 # @DESCRIPTION:
572 # This variable allows overriding of default repository
573 # name. Specify only if this differ from PN and KMNAME.
574 if [[ -n ${EGIT_REPONAME} ]]; then
575 # the repository and kmname different
576 _kmname=${EGIT_REPONAME}
577 elif [[ -n ${KMNAME} ]]; then
578 _kmname=${KMNAME}
352 else 579 else
353 _kmname=${PN} 580 _kmname=${PN}
354 fi 581 fi
355 _kmname_pv="${_kmname}-${PV}" 582
356 case ${KDEBASE} in 583 # default branching
357 kde-base) 584 [[ ${PV} != 9999* && ${KDEBASE} == kde-base ]] && \
358 case ${PV} in 585 EGIT_BRANCH="KDE/$(get_kde_version)"
359 4.3.85 | 4.3.9[0568]) 586
360 # block for normally packed unstable releases 587 # default repo uri
361 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" ;; 588 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}"
362 4.3.[6-9]*) 589
363 SRC_URI="http://dev.gentooexperimental.org/~alexxy/kde/${PV}/${_kmname_pv}.tar.lzma" ;; 590 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
364 *) SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" ;; 591 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
365 esac
366 ;;
367 koffice)
368 case ${PV} in
369 2.0.[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/src/${_kmname_pv}.tar.bz2" ;;
370 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
371 esac
372 esac
373 unset _kmname _kmname_pv
374 fi
375 ;; 592 ;;
593 esac
594}
595
596case ${BUILD_TYPE} in
597 live) _calculate_live_repo ;;
598 *) _calculate_src_uri ;;
376esac 599esac
377 600
378debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}" 601debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
379 602
380# @ECLASS-VARIABLE: PREFIX 603# @ECLASS-VARIABLE: PREFIX
381# @DESCRIPTION: 604# @DESCRIPTION:
382# Set the installation PREFIX for non kde-base applications. It defaults to /usr. 605# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
383# kde-base packages go into KDE4 installation directory (KDEDIR) by default. 606# kde-base packages go into KDE4 installation directory (/usr).
384# No matter the PREFIX, package will be built against KDE installed in KDEDIR. 607# No matter the PREFIX, package will be built against KDE installed in /usr.
385 608
386# @FUNCTION: kde4-base_pkg_setup 609# @FUNCTION: kde4-base_pkg_setup
387# @DESCRIPTION: 610# @DESCRIPTION:
388# Do the basic kdeprefix KDEDIR settings and determine with which kde should 611# Do some basic settings
389# optional applications link
390kde4-base_pkg_setup() { 612kde4-base_pkg_setup() {
391 debug-print-function ${FUNCNAME} "$@" 613 debug-print-function ${FUNCNAME} "$@"
392 614
393 # Prefix compat: 615 if has handbook ${IUSE} || has "+handbook" ${IUSE} && [ "${KDE_HANDBOOK}" != optional ] ; then
394 use prefix || EROOT=${ROOT} 616 eqawarn "Handbook support is enabled via KDE_HANDBOOK=optional in the ebuild."
395 # Append missing trailing slash character 617 eqawarn "Please do not just set IUSE=handbook, as this leads to dependency errors."
396 [[ ${EROOT} = */ ]] || EROOT+="/" 618 fi
397 619
398 # QA ebuilds 620 if use_if_iuse kdeprefix; then
399 [[ -z ${KDE_MINIMAL_VALID} ]] && ewarn "QA Notice: ignoring invalid KDE_MINIMAL (defaulting to ${KDE_MINIMAL})." 621 eerror "Sorry, kdeprefix support has been removed."
622 eerror "Please remove kdeprefix from your USE variable."
623 die "kdeprefix support has been removed"
624 fi
625
626 if [[ ${CATEGORY}/${PN} != kde-base/kdelibs && ${CATEGORY}/${PN} != kde-base/kde-env ]] && \
627 { [[ ${KDE_REQUIRED} == always ]] || { [[ ${KDE_REQUIRED} == optional ]] && use kde; }; } && \
628 has_version kde-base/kdelibs[kdeprefix]; then
629 eerror "Sorry, kdeprefix support has been removed."
630 eerror "Please rebuild kdelibs without kdeprefix support."
631 die "kdeprefix support has been removed"
632 fi
400 633
401 # Don't set KDEHOME during compilation, it will cause access violations 634 # Don't set KDEHOME during compilation, it will cause access violations
402 unset KDEHOME 635 unset KDEHOME
403 636
404 if [[ ${KDEBASE} = kde-base ]]; then 637 # Check if gcc compiler is fresh enough.
405 if use kdeprefix; then 638 # In theory should be in pkg_pretend but we check it only for kdelibs there
406 KDEDIR="${EROOT}usr/kde/${_kdedir}" 639 # and for others we do just quick scan in pkg_setup because pkg_pretend
407 else 640 # executions consume quite some time.
408 KDEDIR="${EROOT}usr" 641 # We can only do this for EAPI 4 or later because the MERGE_TYPE variable
642 # is otherwise undefined.
643 if [[ ${EAPI:-0} != 3 ]]; then
644 if [[ ${MERGE_TYPE} != binary ]]; then
645 [[ $(gcc-major-version) -lt 4 ]] || \
646 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) \
647 && die "Sorry, but gcc-4.3 and earlier wont work for KDE (see bug 354837)."
409 fi 648 fi
410 PREFIX="${PREFIX:-${KDEDIR}}"
411 else
412 # Determine KDEDIR by loooking for the closest match with KDE_MINIMAL
413 KDEDIR=
414 local kde_minimal_met
415 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
416 [[ -z ${kde_minimal_met} ]] && [[ ${slot} = ${KDE_MINIMAL} ]] && kde_minimal_met=1
417 if [[ -n ${kde_minimal_met} ]] && has_version "kde-base/kdelibs:${slot}"; then
418 if has_version "kde-base/kdelibs:${slot}[kdeprefix]"; then
419 KDEDIR="${EROOT}usr/kde/${slot}"
420 else
421 KDEDIR="${EROOT}usr"
422 fi
423 break;
424 fi
425 done
426 unset slot
427
428 # Bail out if kdelibs required but not found
429 if [[ ${KDE_REQUIRED} = always ]] || { [[ ${KDE_REQUIRED} = optional ]] && use kde; }; then
430 [[ -z ${KDEDIR} ]] && die "Failed to determine KDEDIR!"
431 else
432 [[ -z ${KDEDIR} ]] && KDEDIR="${EROOT}usr"
433 fi 649 fi
434 650
435 PREFIX="${PREFIX:-${EROOT}usr}" 651 KDEDIR=/usr
436 fi 652 : ${PREFIX:=/usr}
437 # Point pkg-config path to KDE *.pc files 653 EKDEDIR=${EPREFIX}/usr
438 export PKG_CONFIG_PATH="${KDEDIR}/$(get_libdir)/pkgconfig${PKG_CONFIG_PATH:+:${PKG_CONFIG_PATH}}" 654
439 # Point to correct QT plugins path 655 # Point to correct QT plugins path
440 QT_PLUGIN_PATH="${KDEDIR}/$(get_libdir)/kde4/plugins/" 656 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
441 657
442 # Fix XDG collision with sandbox 658 # Fix XDG collision with sandbox
443 export XDG_CONFIG_HOME="${T}" 659 export XDG_CONFIG_HOME="${T}"
444 # Not needed anymore
445 unset _kdedir
446} 660}
447 661
448# @FUNCTION: kde4-base_src_unpack 662# @FUNCTION: kde4-base_src_unpack
449# @DESCRIPTION: 663# @DESCRIPTION:
450# This function unpacks the source tarballs for KDE4 applications. 664# This function unpacks the source tarballs for KDE4 applications.
451kde4-base_src_unpack() { 665kde4-base_src_unpack() {
452 debug-print-function ${FUNCNAME} "$@" 666 debug-print-function ${FUNCNAME} "$@"
453 667
454 if [[ ${BUILD_TYPE} = live ]]; then 668 if [[ ${BUILD_TYPE} = live ]]; then
669 case ${KDE_SCM} in
670 svn)
455 migrate_store_dir 671 migrate_store_dir
456 subversion_src_unpack 672 subversion_src_unpack
673 ;;
674 git)
675 git-2_src_unpack
676 ;;
677 esac
457 else 678 else
458 base_src_unpack 679 unpack ${A}
459 fi 680 fi
460} 681}
461 682
462# @FUNCTION: kde4-base_src_prepare 683# @FUNCTION: kde4-base_src_prepare
463# @DESCRIPTION: 684# @DESCRIPTION:
466# enable_selected_linguas() and enable_selected_doc_linguas() 687# enable_selected_linguas() and enable_selected_doc_linguas()
467# in kde4-functions.eclass(5) for further details. 688# in kde4-functions.eclass(5) for further details.
468kde4-base_src_prepare() { 689kde4-base_src_prepare() {
469 debug-print-function ${FUNCNAME} "$@" 690 debug-print-function ${FUNCNAME} "$@"
470 691
692 # enable handbook and linguas only when not using live ebuild
693
471 # Only enable selected languages, used for KDE extragear apps. 694 # Only enable selected languages, used for KDE extragear apps.
472 if [[ -n ${KDE_LINGUAS} ]]; then 695 if [[ -n ${KDE_LINGUAS} ]]; then
473 enable_selected_linguas 696 enable_selected_linguas
474 fi 697 fi
475 698
476 # Enable/disable handbooks for kde4-base packages 699 # Enable/disable handbooks for kde4-base packages
477 # kde-l10n inherits kde4-base but is metpackage, so no check for doc 700 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
478 # kdelibs inherits kde4-base but handle installing the handbook itself 701 # kdelibs inherits kde4-base but handle installing the handbook itself
479 if ! has kde4-meta ${INHERITED}; then 702 if ! has kde4-meta ${INHERITED} && in_iuse handbook; then
480 has handbook ${IUSE//+} && [[ ${PN} != kde-l10n ]] && [[ ${PN} != kdelibs ]] && enable_selected_doc_linguas 703 if [[ ${KDEBASE} == kde-base ]]; then
704 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
705 # documentation in kde4-functions
706 : ${KDE_DOC_DIRS:=doc}
707 local dir
708 for dir in ${KDE_DOC_DIRS}; do
709 sed -e "\!^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
710 -e "\!^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
711 -e "\!^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
712 -e "\!^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
713 -i CMakeLists.txt || die "failed to comment out handbook"
714 done
715 fi
716 else
717 enable_selected_doc_linguas
481 fi 718 fi
719 fi
482 720
483 [[ ${BUILD_TYPE} = live ]] && subversion_src_prepare 721 # SCM bootstrap
722 if [[ ${BUILD_TYPE} = live ]]; then
723 case ${KDE_SCM} in
724 svn) subversion_src_prepare ;;
725 esac
726 fi
727
728 # Apply patches
484 base_src_prepare 729 base_src_prepare
485 730
486 # Save library dependencies 731 # Save library dependencies
487 if [[ -n ${KMSAVELIBS} ]] ; then 732 if [[ -n ${KMSAVELIBS} ]] ; then
488 save_library_dependencies 733 save_library_dependencies
490 735
491 # Inject library dependencies 736 # Inject library dependencies
492 if [[ -n ${KMLOADLIBS} ]] ; then 737 if [[ -n ${KMLOADLIBS} ]] ; then
493 load_library_dependencies 738 load_library_dependencies
494 fi 739 fi
740
741 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/...
742 if [[ -z ${KDEBASE} ]]; then
743 find "${S}" -name "*.docbook" \
744 -exec sed -i -r \
745 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
746 || die 'failed to fix DocBook variant version'
747 fi
495} 748}
496 749
497# @FUNCTION: kde4-base_src_configure 750# @FUNCTION: kde4-base_src_configure
498# @DESCRIPTION: 751# @DESCRIPTION:
499# Function for configuring the build of KDE4 applications. 752# Function for configuring the build of KDE4 applications.
500kde4-base_src_configure() { 753kde4-base_src_configure() {
501 debug-print-function ${FUNCNAME} "$@" 754 debug-print-function ${FUNCNAME} "$@"
502 755
756 # Build tests in src_test only, where we override this value
757 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
758
759 if use_if_iuse debug; then
760 # Set "real" debug mode
761 CMAKE_BUILD_TYPE="Debugfull"
762 else
503 # Handle common release builds 763 # Handle common release builds
504 if ! has debug ${IUSE//+} || ! use debug; then
505 append-cppflags -DQT_NO_DEBUG 764 append-cppflags -DQT_NO_DEBUG
506 fi 765 fi
507 766
508 # Build tests in src_test only, where we override this value
509 local cmakeargs="-DKDE4_BUILD_TESTS=OFF"
510
511 # set "real" debug mode
512 if has debug ${IUSE//+} && use debug; then
513 CMAKE_BUILD_TYPE="Debugfull"
514 fi
515
516 # Set distribution name 767 # Set distribution name
517 [[ ${PN} = kdelibs ]] && cmakeargs+=" -DKDE_DISTRIBUTION_TEXT=Gentoo" 768 [[ ${PN} = kdelibs ]] && cmakeargs+=(-DKDE_DISTRIBUTION_TEXT=Gentoo)
518 769
519 # Here we set the install prefix 770 # Here we set the install prefix
520 cmakeargs+=" -DCMAKE_INSTALL_PREFIX=${PREFIX}" 771 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
521 772
522 # Use colors 773 # Use colors
523 QTEST_COLORED=1 774 QTEST_COLORED=1
524 775
525 # Shadow existing /usr installations 776 # Shadow existing installations
526 unset KDEDIRS 777 unset KDEDIRS
527 778
528 # Handle kdeprefix-ed KDE 779 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
529 if [[ ${KDEDIR} != "${EROOT}usr" ]]; then 780 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
530 # Override some environment variables - only when kdeprefix is different, 781 #kde-config -path data unavailable when cross-compiling
531 # to not break ccache/distcc 782 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
532 PATH="${KDEDIR}/bin:${PATH}"
533 LDPATH="${KDEDIR}/$(get_libdir):${LDPATH}"
534 783
535 # Append full RPATH
536 cmakeargs+=" -DCMAKE_SKIP_RPATH=OFF"
537
538 # Set cmake prefixes to allow buildsystem to locate valid KDE installation
539 # when more are present
540 cmakeargs+=" -DCMAKE_SYSTEM_PREFIX_PATH=${KDEDIR}"
541 fi
542
543 # Handle kdeprefix in application itself
544 if ! has kdeprefix ${IUSE//+} || ! use kdeprefix; then
545 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc 784 # sysconf needs to be /etc, not /usr/etc
546 cmakeargs+=" -DSYSCONF_INSTALL_DIR=${EROOT}etc" 785 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
547 fi
548 786
787 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
788 mycmakeargs=(${mycmakeargs})
789 fi
790
549 mycmakeargs="${cmakeargs} ${mycmakeargs}" 791 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
550 792
551 cmake-utils_src_configure 793 cmake-utils_src_configure
552} 794}
553 795
554# @FUNCTION: kde4-base_src_compile 796# @FUNCTION: kde4-base_src_compile
565# Function for testing KDE4 applications. 807# Function for testing KDE4 applications.
566kde4-base_src_test() { 808kde4-base_src_test() {
567 debug-print-function ${FUNCNAME} "$@" 809 debug-print-function ${FUNCNAME} "$@"
568 810
569 # Override this value, set in kde4-base_src_configure() 811 # Override this value, set in kde4-base_src_configure()
570 mycmakeargs+=" -DKDE4_BUILD_TESTS=ON" 812 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
571 cmake-utils_src_configure 813 cmake-utils_src_configure
572 kde4-base_src_compile 814 kde4-base_src_compile
573 815
816 # When run as normal user during ebuild development with the ebuild command, the
817 # kde tests tend to access the session DBUS. This however is not possible in a real
818 # emerge or on the tinderbox.
819 # > make sure it does not happen, so bad tests can be recognized and disabled
820 unset DBUS_SESSION_BUS_ADDRESS
821
822 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
823 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
824 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
825 # surprise- we are already INSIDE virtualmake!!!
826 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
827 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
828 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
829 debug-print " kde4-base.eclass docs for details... Applying workaround."
830 cmake-utils_src_test
831 else
832 VIRTUALX_COMMAND="cmake-utils_src_test" virtualmake
833 fi
834 else
574 cmake-utils_src_test 835 cmake-utils_src_test
836 fi
575} 837}
576 838
577# @FUNCTION: kde4-base_src_install 839# @FUNCTION: kde4-base_src_install
578# @DESCRIPTION: 840# @DESCRIPTION:
579# Function for installing KDE4 applications. 841# Function for installing KDE4 applications.
582 844
583 if [[ -n ${KMSAVELIBS} ]] ; then 845 if [[ -n ${KMSAVELIBS} ]] ; then
584 install_library_dependencies 846 install_library_dependencies
585 fi 847 fi
586 848
587 kde4-base_src_make_doc 849 # Install common documentation of KDE4 applications
850 local doc
851 if ! has kde4-meta ${INHERITED}; then
852 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
853 [[ -f ${doc} && -s ${doc} ]] && dodoc "${doc}"
854 done
855 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
856 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
857 done
858 fi
859
588 cmake-utils_src_install 860 cmake-utils_src_install
589}
590 861
591# @FUNCTION: kde4-base_src_make_doc 862 # In EAPI 4+, we don't want ${PREFIX}/share/doc/HTML to be compressed,
592# @DESCRIPTION: 863 # because then khelpcenter can't find the docs
593# Function for installing the documentation of KDE4 applications. 864 [[ ${EAPI:-0} != 3 && -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
594kde4-base_src_make_doc() { 865 docompress -x ${PREFIX}/share/doc/HTML
595 debug-print-function ${FUNCNAME} "$@" 866}
596 867
597 local doc 868# @FUNCTION: kde4-base_pkg_preinst
598 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 869# @DESCRIPTION:
599 [[ -s ${doc} ]] && dodoc ${doc} 870# Function storing icon caches
600 done 871kde4-base_pkg_preinst() {
872 debug-print-function ${FUNCNAME} "$@"
601 873
602 if [[ -z ${KMNAME} ]]; then 874 gnome2_icon_savelist
603 for doc in {apps,runtime,workspace,.}/*/{AUTHORS,README*}; do 875 if [[ ${BUILD_TYPE} == live && ${KDE_SCM} == svn ]]; then
604 if [[ -s ${doc} ]]; then 876 subversion_pkg_preinst
605 local doc_complete=${doc}
606 doc="${doc#*/}"
607 newdoc "$doc_complete" "${doc%/*}.${doc##*/}"
608 fi
609 done
610 fi
611
612 if [[ -n ${KDEBASE} ]] && [[ -d "${D}${EROOT}usr/share/doc/${PF}" ]]; then
613 # work around bug #97196
614 dodir /usr/share/doc/KDE4 && \
615 cp -r "${D}${EROOT}usr/share/doc/${PF}" "${D}${EROOT}usr/share/doc/KDE4/" || \
616 die "Failed to move docs to KDE4/."
617 rm -rf "${D}${EROOT}usr/share/doc/${PF}"
618 fi 877 fi
619} 878}
620 879
621# @FUNCTION: kde4-base_pkg_postinst 880# @FUNCTION: kde4-base_pkg_postinst
622# @DESCRIPTION: 881# @DESCRIPTION:
623# Function to rebuild the KDE System Configuration Cache after an application has been installed. 882# Function to rebuild the KDE System Configuration Cache after an application has been installed.
624kde4-base_pkg_postinst() { 883kde4-base_pkg_postinst() {
625 debug-print-function ${FUNCNAME} "$@" 884 debug-print-function ${FUNCNAME} "$@"
626 885
886 gnome2_icon_cache_update
887 fdo-mime_desktop_database_update
888 fdo-mime_mime_database_update
627 buildsycoca 889 buildsycoca
628 890
629 if [[ ${BUILD_TYPE} = live ]] && [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 891 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
892 if [[ ${BUILD_TYPE} = live ]]; then
630 echo 893 echo
631 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}" 894 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
632 einfo "Use it at your own risk." 895 einfo "Use it at your own risk."
633 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!" 896 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
634 echo 897 echo
635 elif [[ ${BUILD_TYPE} != live ]] && [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]] && has kdeprefix ${IUSE//+} && use kdeprefix; then 898 fi
636 # warning about kdeprefix for non-live users 899 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
900 if [[ ${KDEBASE} != kde-base ]] && \
901 ! has_version 'kde-base/kdebase-runtime-meta' && \
902 ! has_version 'kde-base/kdebase-startkde'; then
903 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
637 echo 904 echo
638 ewarn "WARNING! You have the kdeprefix useflag enabled." 905 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
639 ewarn "This setting is strongly discouraged and might lead to potential trouble" 906 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
640 ewarn "with KDE update strategies." 907 ewarn "With this setting you are unsupported by KDE team."
641 ewarn "You are using this setup at your own risk and the kde team does not" 908 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
642 ewarn "take responsibilities for dead kittens." 909 fi
643 echo 910 fi
644 fi 911 fi
645} 912}
646 913
647# @FUNCTION: kde4-base_pkg_postrm 914# @FUNCTION: kde4-base_pkg_postrm
648# @DESCRIPTION: 915# @DESCRIPTION:
649# Function to rebuild the KDE System Configuration Cache after an application has been removed. 916# Function to rebuild the KDE System Configuration Cache after an application has been removed.
650kde4-base_pkg_postrm() { 917kde4-base_pkg_postrm() {
651 debug-print-function ${FUNCNAME} "$@" 918 debug-print-function ${FUNCNAME} "$@"
652 919
920 gnome2_icon_cache_update
921 fdo-mime_desktop_database_update
922 fdo-mime_mime_database_update
653 buildsycoca 923 buildsycoca
654} 924}

Legend:
Removed from v.1.53  
changed lines
  Added in v.1.112

  ViewVC Help
Powered by ViewVC 1.1.20